VTK: vtkClosestNPointsStrategy Class Reference

| VTK 9.3.1

Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkClosestNPointsStrategy Class Reference

implement a specific vtkPointSet::FindCell() strategy based on the N closest points More...

`#include <vtkClosestNPointsStrategy.h>`

Inheritance diagram for vtkClosestNPointsStrategy:
[legend]
Collaboration diagram for vtkClosestNPointsStrategy:
[legend]

## Public Member Functions
vtkIdType | FindCell (double x[3], vtkCell *cell, vtkGenericCell *gencell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights) override
| Implement the specific strategy. More...
void | CopyParameters (vtkFindCellStrategy *from) override
| Copy essential parameters between instances of this class. More...
int | Initialize (vtkPointSet *ps) override
| Provide the necessary initialization method (see superclass for more information). More...
virtual void | SetClosestNPoints (int)
| Set / get the value for the N closest points. More...
virtual int | GetClosestNPoints ()
| Set / get the value for the N closest points. More...
Public Member Functions inherited from vtkClosestPointStrategy
int | Initialize (vtkPointSet *ps) override
| Provide the necessary initialization method (see superclass for more information). More...
vtkIdType | FindCell (double x[3], vtkCell *cell, vtkGenericCell *gencell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights) override
| Implement the specific strategy. More...
vtkIdType | FindClosestPointWithinRadius (double x[3], double radius, double closestPoint[3], vtkGenericCell *cell, vtkIdType &cellId, int &subId, double &dist2, int &inside) override
| Implement the specific strategy. More...
bool | InsideCellBounds (double x[3], vtkIdType cellId) override
| Implement the specific strategy. More...
vtkCell * | SelectCell (vtkPointSet *self, vtkIdType cellId, vtkCell *cell, vtkGenericCell *gencell)
| Subclasses use this method to select the current cell. More...
void | CopyParameters (vtkFindCellStrategy *from) override
| Copy essential parameters between instances of this class. More...
virtual void | SetPointLocator (vtkAbstractPointLocator *)
| Set / get an instance of vtkAbstractPointLocator which is used to implement the strategy for FindCell(). More...
virtual vtkAbstractPointLocator * | GetPointLocator ()
| Set / get an instance of vtkAbstractPointLocator which is used to implement the strategy for FindCell(). More...
vtkClosestPointStrategy * | NewInstance () const
| Standard methods for type information and printing. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for type information and printing. More...
Public Member Functions inherited from vtkFindCellStrategy
vtkFindCellStrategy * | NewInstance () const
| Standard methods for type information and printing. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for type information and printing. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkClosestNPointsStrategy * | New ()
| Construct a vtkFindCellStrategy subclass. More...
Static Public Member Functions inherited from vtkClosestPointStrategy
static vtkClosestPointStrategy * | New ()
| Construct a vtkFindCellStrategy subclass. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for type information and printing. More...
static vtkClosestPointStrategy * | SafeDownCast (vtkObjectBase *o)
| Standard methods for type information and printing. More...
Static Public Member Functions inherited from vtkFindCellStrategy
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for type information and printing. More...
static vtkFindCellStrategy * | SafeDownCast (vtkObjectBase *o)
| Standard methods for type information and printing. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
| vtkClosestNPointsStrategy ()
| ~vtkClosestNPointsStrategy () override
Protected Member Functions inherited from vtkClosestPointStrategy
| vtkClosestPointStrategy ()
| ~vtkClosestPointStrategy () override
Protected Member Functions inherited from vtkFindCellStrategy
| vtkFindCellStrategy ()
| ~vtkFindCellStrategy () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | ClosestNPoints
Protected Attributes inherited from vtkClosestPointStrategy
std::vector< unsigned char > | VisitedCells
vtkNew< vtkIdList > | VisitedCellIds
vtkNew< vtkIdList > | PointIds
vtkNew< vtkIdList > | Neighbors
vtkNew< vtkIdList > | CellIds
vtkNew< vtkIdList > | NearPointIds
std::vector< double > | Weights
vtkAbstractPointLocator * | PointLocator
Protected Attributes inherited from vtkFindCellStrategy
bool | OwnsLocator
bool | IsACopy
vtkPointSet * | PointSet
double | Bounds [6]
vtkTimeStamp | InitializeTime
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkClosestPointStrategy | Superclass
| Standard methods for type information and printing. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for type information and printing. More...
static vtkClosestNPointsStrategy * | SafeDownCast (vtkObjectBase *o)
| Standard methods for type information and printing. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for type information and printing. More...
vtkClosestNPointsStrategy * | NewInstance () const
| Standard methods for type information and printing. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for type information and printing. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for type information and printing. More...

## Additional Inherited Members
Public Types inherited from vtkClosestPointStrategy
typedef vtkFindCellStrategy | Superclass
| Standard methods for type information and printing. More...
Public Types inherited from vtkFindCellStrategy
typedef vtkObject | Superclass
| Standard methods for type information and printing. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

implement a specific vtkPointSet::FindCell() strategy based on the N closest points

vtkClosestNPointsStrategy is implements a FindCell() strategy based on locating the closest N points in a dataset, and then searching attached cells. This class extends its superclass vtkClosestPointStrategy by looking at the additional N points.

See also
  vtkFindCellStrategy vtkPointSet

Tests:
  vtkClosestNPointsStrategy (Tests)

Definition at line 27 of file vtkClosestNPointsStrategy.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkClosestPointStrategy vtkClosestNPointsStrategy::Superclass

Standard methods for type information and printing.

Definition at line 39 of file vtkClosestNPointsStrategy.h.

## Constructor & Destructor Documentation

## ◆ vtkClosestNPointsStrategy()

vtkClosestNPointsStrategy::vtkClosestNPointsStrategy | ( |  | ) |
| protected

## ◆ ~vtkClosestNPointsStrategy()

vtkClosestNPointsStrategy::~vtkClosestNPointsStrategy | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkClosestNPointsStrategy* vtkClosestNPointsStrategy::New | ( |  | ) |
| static

Construct a vtkFindCellStrategy subclass.

## ◆ IsTypeOf()

static vtkTypeBool vtkClosestNPointsStrategy::IsTypeOf | ( | const char * | type | ) |
| static

Standard methods for type information and printing.

## ◆ IsA()

virtual vtkTypeBool vtkClosestNPointsStrategy::IsA | ( | const char * | type | ) |
| virtual

Standard methods for type information and printing.

Reimplemented from vtkClosestPointStrategy.

## ◆ SafeDownCast()

static vtkClosestNPointsStrategy* vtkClosestNPointsStrategy::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Standard methods for type information and printing.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkClosestNPointsStrategy::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Standard methods for type information and printing.

Reimplemented from vtkClosestPointStrategy.

## ◆ NewInstance()

vtkClosestNPointsStrategy* vtkClosestNPointsStrategy::NewInstance | ( |  | ) | const

Standard methods for type information and printing.

## ◆ PrintSelf()

void vtkClosestNPointsStrategy::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Standard methods for type information and printing.

Reimplemented from vtkObject.

## ◆ FindCell()

vtkIdType vtkClosestNPointsStrategy::FindCell | ( | double | x[3],
|  | vtkCell * | cell,
|  | vtkGenericCell * | gencell,
|  | vtkIdType | cellId,
|  | double | tol2,
|  | int & | subId,
|  | double | pcoords[3],
|  | double * | weights
| ) |  |
| overridevirtual

Implement the specific strategy.

Implements vtkFindCellStrategy.

## ◆ SetClosestNPoints()

virtual void vtkClosestNPointsStrategy::SetClosestNPoints | ( | int |  | ) |
| virtual

Set / get the value for the N closest points.

## ◆ GetClosestNPoints()

virtual int vtkClosestNPointsStrategy::GetClosestNPoints | ( |  | ) |
| virtual

Set / get the value for the N closest points.

## ◆ CopyParameters()

void vtkClosestNPointsStrategy::CopyParameters | ( | vtkFindCellStrategy * | from | ) |
| overridevirtual

Copy essential parameters between instances of this class.

This generally is used to copy from instance prototype to another, or to copy strategies between thread instances. Sub-classes can contribute to the parameter copying process via chaining.

Reimplemented from vtkFindCellStrategy.

## ◆ Initialize()

int vtkClosestPointStrategy::Initialize
| override

Provide the necessary initialization method (see superclass for more information).

This method sets up the point locator, vtkPointSet relationship. It will use the vtkPointSet's default locator if not defined by SetPointLocator() below.

## Member Data Documentation

## ◆ ClosestNPoints

int vtkClosestNPointsStrategy::ClosestNPoints
| protected

Definition at line 72 of file vtkClosestNPointsStrategy.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkClosestNPointsStrategy.h